
var refcontrolPrefs =
{
	getPrefBranch: function()
	{
		var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		return prefService.getBranch("refcontrol.");
	},

	onPopupShowing: function(aEvent)
	{
		// onpopupshowing is inherited by child elements.
		// avoid processing on these
		if (aEvent.target.id != "refcontrol-popupOptions")
			return true;
			
		var prefBranch = this.getPrefBranch();
		var bChecked;
	
		var arrMenuItems = aEvent.target.getElementsByTagName("menuitem");
		for (var i = 0; i < arrMenuItems.length; i++)
		{
			var type = arrMenuItems[i].getAttribute('type');
			switch (type)
			{
				case 'checkbox':
				case 'radio':
					try {
						if (type == 'checkbox')
							bChecked = prefBranch.getBoolPref(arrMenuItems[i].value);
						else if (type == 'radio')
							bChecked = (prefBranch.getIntPref(arrMenuItems[i].getAttribute('name')) == arrMenuItems[i].value);
					} catch (e) {
						bChecked = false;
					}
					if (bChecked)
						arrMenuItems[i].setAttribute("checked", true);
					else
						arrMenuItems[i].removeAttribute("checked");
					break;
			}
		}
		
		return true;
	},
	
	onChangeCheckboxPref: function(aEvent)
	{
		try {
			this.getPrefBranch().setBoolPref(aEvent.target.value, !!aEvent.target.getAttribute('checked'));
		} catch (ex) {
			myDump("onChangeCheckboxPref: " + ex);
		}
	},
	
	onChangeRadioPref: function(aEvent)
	{
		try {
			this.getPrefBranch().setIntPref(aEvent.target.getAttribute('name'), aEvent.target.value);
		} catch (ex) {
			myDump("onChangeRadioPref: " + ex);
		}
	}
};
